require'ecrf/htk'
require'ecrf/split'

function queryallseries()
  local series,seriest,b,s;
  if CGI('source')=='(local)' then
    s = servercommand('get_param:MyACRNema')
  else
    s = CGI('source')
  end

  b=newdicomobject();
  b.PatientID        = CGI('patientidmatch')
  b.StudyDate        = CGI('studydatematch')
  b.StudyInstanceUID = '';
  b.StudyDescription = '';
  b.SeriesDescription= '';
  b.SeriesInstanceUID= '';
  b.Modality         = CGI('modality')
  b.SeriesTime       = '';

  series=dicomquery(s, 'SERIES', b);

  -- convert returned DDO (userdata) to table; needed to allow table.sort
  seriest={}
  for k1=0,#series-1 do
    seriest[k1+1]={}
    seriest[k1+1].StudyDate        = series[k1].StudyDate
    seriest[k1+1].PatientID        = series[k1].PatientID
    seriest[k1+1].StudyDate        = series[k1].StudyDate
    seriest[k1+1].SeriesTime       = series[k1].SeriesTime
    seriest[k1+1].StudyInstanceUID = series[k1].StudyInstanceUID
    seriest[k1+1].SeriesDescription= series[k1].SeriesDescription
    seriest[k1+1].StudyDescription = series[k1].StudyDescription
    seriest[k1+1].SeriesInstanceUID= series[k1].SeriesInstanceUID
    seriest[k1+1].Modality         = series[k1].Modality
  end
  return seriest
end

HTML('Content-type: text/html\n\n');

print
[[
<html>
<head>
<title>Test for browser</title>
<style type="text/css">
body { font:10pt Verdana; }
a { color:blue; }
#content { background-color:#dddddd; width:200px; margin-top:2px; }
</style>
</head>
<body>
]]

print
[[
<script type="text/javascript">
function toggle(id)
{ var e = document.getElementById(id);
  if (e.style.display == '')
    e.style.display = 'none';
  else
    e.style.display = '';
}
</script>
]]

print
[[
<SCRIPT LANGUAGE="JavaScript">
<!-- Idea by:  Nic Wolfe -->
<!-- This script and many more are available free online at -->
<!-- The JavaScript Source!! http://javascript.internet.com -->

<!-- Begin
function popUp(URL)
{ day = new Date();
  id = day.getTime();
  eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=0,location=0,statusbar=0, menubar=0,resizable=1,width=600,height=500,left = 0,top = 0');");
}
// End -->
</script>
]]

print
[[
<script>
function PopupCenter(pageURL, title,w,h)
{ var left = (screen.width/2)-(w/2);
  var top = (screen.height/2)-(h/2);
  var targetWin = window.open (pageURL, title, 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width='+w+', height='+h+', top='+top+', left='+left);
}
</script>
]]

local key = CGI('key')
local query = "key='".. key .."'"

local series=queryallseries()
table.sort(series, function(a,b) return a.StudyInstanceUID<b.StudyInstanceUID end)

print(htk.H3{'Scans for this patient'})

print'<ul>'
for i=1,#series do
  if series[i].StudyDate=='' then series[i].StudyDate = series[i].SeriesDate end
  if series[i].StudyDate=='' or series[i].StudyDate==nil then series[i].StudyDate = 'Unknown' end

  local split = (i==1) or (series[i-1].StudyInstanceUID ~= series[i].StudyInstanceUID)

  if split and i~=1 then
    print '    </ul>'
    print '  </li>'
  end

  if split then
    print ('  <li>')
	print ('    Date:')
	print([[    <a href="#" onclick="toggle('node]]..i..[[')">]],  series[i].StudyDate)
	print('    </a>')
	print(     series[i].StudyDescription)

	print([[   <a href=# onclick="javascript:PopupCenter('dgate.exe?mode=markstudy&study=]]
               ..series[i].PatientID..':'..series[i].StudyInstanceUID..[[&key=]]..key..[[&source=]]..CGI('source')..[[', 'Scan', 400, 500)">[submit]</a>]]
         )

	if #series>10 then
	  print('    <ul id=node'..i..' style="display:none">')
	else
	  print('    <ul id=node'..i..' >')
	end
  end

  print('    <li>')

  print([[     <a href=# onclick="javascript:PopupCenter('dgate.exe?mode=ecrf/wadoviewer&patientidmatch=]]
               ..series[i].PatientID..[[&seriesUID=]]..series[i].SeriesInstanceUID..[[&source=]]..CGI('source')..[[', 'Scan', 400, 500)">[view]</a>]]
       )

  print([[     <a href=# onclick="javascript:PopupCenter('dgate.exe?mode=markseries&series=]]
               ..series[i].PatientID..':'..series[i].SeriesInstanceUID..[[&key=]]..key..[[&source=]]..CGI('source')..[[', 'Scan', 400, 500)">[submit]</a>]]
       )
  print('      ', series[i].Modality, series[i].SeriesTime, series[i].SeriesDescription)
print('    </li>')
end

print '    </ul>'
print '  </li>'
print'</ul>'

print
[[
</body>
</html>
]]
